package icfp2001;

import java.util.*;

class OverlapInversion implements Runnable {

private Thread           thread;
private String s = null;
private boolean ende = false;

private String[] startTags = {"<B>","<I>","<TT>","<S>","<U>", "<0>","<1>",
                              "<2>","<3>","<4>", "<5>","<6>", "<7>","<8>",
                              "<9>","<r>","<g>", "<b>","<c>", "<m>","<y>",
                              "<k>","<w>"};
private String[] endTags =   {"</B>","</I>","</TT>","</S>","</U>", "</0>",
                              "</1>","</2>","</3>", "</4>","</5>", "</6>",
                              "</7>","</8>","</9>", "</r>","</g>", "</b>",
                              "</c>","</m>","</y>", "</k>","</w>"};




/**
 * Starts the Thread.
 */
public void startMe(String s) {
   this.s = s;

   thread = new Thread( this );
   thread.start();
}


/**
 * Returns the String.
 */
public String getString() {
   return s;
}

/**
 * Checks the Thread: running?
 */
public boolean isAlive() {
   if ( thread != null )
      return thread.isAlive();
   return false;
}

/**
 */
public void breakIt() {
   this.ende=true;
}

/**
 * Starts the Thread.
 */
public void run() {
   int pos=0;
   String tag = null;
   //Variables for Sequences
   Vector[] sequence = new Vector[4];
   Vector[] spaces   = new Vector[4];
   Vector[] helpSeq = new Vector[4];
   int[]    seqPos = new int[4];
   int      seqNr=0;
   for (int i=0; i<4; i++) {
      sequence[i]=new Vector();
      spaces[i]=new Vector();
   }
   for (int i=0; i<4; i++)
      helpSeq[i]=new Vector();

   while (((pos=s.indexOf("<", pos)) != -1) && (!ende)) {
      //search first tag from position pos
      tag = s.substring(s.indexOf("<", pos),
                        s.indexOf(">", pos)+1);
      seqPos[seqNr]=pos;
      sequence[seqNr].addElement(tag);
      pos+=tag.length();
      //add all starting tags till there is text or a closing tag
      while (((s.indexOf("<", pos))!=-1) &&
             (substringEmpty(tag=s.substring(pos,s.indexOf("<", pos))))) {
         spaces[seqNr].addElement(s.substring(pos,s.indexOf("<", pos)));
         pos=s.indexOf("<", pos);
         //search next tag from position pos
         tag = s.substring(s.indexOf("<", pos),
                           s.indexOf(">", pos)+1);
         pos+=tag.length();
         sequence[seqNr].addElement(tag);
      }

      seqNr++;
      switch (seqNr) {
         case 1: if ((sequence[0].size()==1) ||
                     (endTagsInSeq(sequence[0]))) {
                    seqNr=0;
                    sequence[0].removeAllElements();
                    spaces[0].removeAllElements();
                 }
                 break;
         case 2:if ((helpSeq = getHelpSeq((Vector)sequence[0].clone(),
                                          (Vector)sequence[1].clone(),
                                          (Vector)spaces[1].clone())) == null) {
                    seqNr=0;
                    sequence[0].removeAllElements();
                    sequence[1].removeAllElements();
                    spaces[0].removeAllElements();
                    spaces[1].removeAllElements();
                 }
                 break;
         case 3: if (!selfdestruct(helpSeq[1],
                                   sequence[2])) {
                    pos=seqPos[1];
                    seqNr=0;
                    sequence[0].removeAllElements();
                    sequence[1].removeAllElements();
                    sequence[2].removeAllElements();
                    helpSeq[0].removeAllElements();
                    helpSeq[1].removeAllElements();
                    helpSeq[2].removeAllElements();
                    helpSeq[3].removeAllElements();
                    spaces[0].removeAllElements();
                    spaces[1].removeAllElements();
                    spaces[2].removeAllElements();
                 }
                 break;
         case 4: if (!selfdestruct(helpSeq[0],
                                   sequence[3])) {
                    pos=seqPos[1];
                    seqNr=0;
                    sequence[0].removeAllElements();
                    sequence[1].removeAllElements();
                    sequence[2].removeAllElements();
                    sequence[3].removeAllElements();
                    helpSeq[0].removeAllElements();
                    helpSeq[1].removeAllElements();
                    helpSeq[2].removeAllElements();
                    helpSeq[3].removeAllElements();
                    spaces[0].removeAllElements();
                    spaces[1].removeAllElements();
                    spaces[2].removeAllElements();
                    spaces[3].removeAllElements();
                 }
                 else {
                    StringBuffer sb = new StringBuffer(s);
                    for (int i=0; i<sequence[2].size(); i++)
                       sb.delete(seqPos[2],
                                 seqPos[2]+sequence[2].elementAt(i).toString().length());
                    if (!spaces[2].isEmpty())
                       for (int i=0; i<spaces[2].size(); i++)
                          sb.delete(seqPos[2],
                                    seqPos[2]+spaces[2].elementAt(i).toString().length());
                    for (int i=0; i<sequence[3].size(); i++)
                       sb.insert(seqPos[2],
                                 startTags[getEndTagNumber(sequence[3].elementAt(i).toString())]);
                    for (int i=0; i<sequence[0].size(); i++)
                       sb.insert(seqPos[2],
                                 endTags[getStartTagNumber(sequence[0].elementAt(i).toString())]);
                    for (int i=sequence[3].size()-1; i>=0; i--)
                       sb.insert(seqPos[2],
                                 sequence[3].elementAt(i).toString());
                    if (!spaces[2].isEmpty())
                       for (int i=0; i<spaces[2].size(); i++)
                             sb.insert(seqPos[2],
                                       spaces[2].elementAt(i).toString());
                    for (int i=0; i<sequence[1].size(); i++)
                       sb.delete(seqPos[1],
                                 seqPos[1]+sequence[1].elementAt(i).toString().length());
                    if (!spaces[1].isEmpty())
                       for (int i=0; i<spaces[1].size(); i++)
                          sb.delete(seqPos[1],
                                    seqPos[1]+spaces[1].elementAt(i).toString().length());
                    if (!helpSeq[3].isEmpty())
                       for (int i=0; i<helpSeq[3].size(); i++)
                             sb.insert(seqPos[1],
                                       helpSeq[3].elementAt(i).toString());
                    for (int i=0; i<sequence[3].size(); i++)
                       sb.insert(seqPos[1],
                                 startTags[getEndTagNumber(sequence[3].elementAt(i).toString())]);
                    if (!helpSeq[2].isEmpty())
                       for (int i=0; i<helpSeq[2].size(); i++)
                             sb.insert(seqPos[1],
                                       helpSeq[2].elementAt(i).toString());
                    s=sb.toString();

                    pos=seqPos[1];
                    seqNr=0;
                    sequence[0].removeAllElements();
                    sequence[1].removeAllElements();
                    sequence[2].removeAllElements();
                    sequence[3].removeAllElements();
                    helpSeq[0].removeAllElements();
                    helpSeq[1].removeAllElements();
                    helpSeq[2].removeAllElements();
                    helpSeq[3].removeAllElements();
                    spaces[0].removeAllElements();
                    spaces[1].removeAllElements();
                    spaces[2].removeAllElements();
                    spaces[3].removeAllElements();
                 }
                 break;
      }
   }

}


/**
 * i.e.: v1 = ["<B>","<I>"]
 *       v2 = ["</I>","</B>","<TT>","<I>","<B>"]
 *       helpSeq = ["<TT>"]
 */
private Vector[] getHelpSeq(Vector v1, Vector v2, Vector spaces) {
   if (v2.size() < (1+2*v1.size()))
      return null;

   Vector[] helpSeq = new Vector[4];
   for (int i=0; i<4; i++)
      helpSeq[i]=new Vector();

   for (int i=0; i<v1.size(); i++)
      helpSeq[2].addElement(spaces.elementAt(i));
   for (int i=0; i<(spaces.size()-v1.size()); i++)
      helpSeq[3].addElement(spaces.elementAt(spaces.size()-1-i));

   int size = v1.size()-1;

   for (int i=0; i<v1.size(); i++)
      if ((getStartTagNumber(v1.elementAt(size-i).toString())) !=
          (getEndTagNumber(v2.elementAt(0).toString())))
         return null;
      else v2.removeElementAt(0);

   size=v2.size()-v1.size();
   for (int i=v2.size()-1; i>=size; i--)
      if (!inVec(v2.elementAt(i),v1))
         return null;
      else {
         helpSeq[1].insertElementAt(v2.elementAt(i), 0);
         v2.removeElementAt(i);
      }

   helpSeq[0] = (Vector)v2.clone();

   return helpSeq;
}

/**
 * the same closing tags in v2 as opening in v1 ????
 */
private boolean selfdestruct(Vector v1, Vector v2) {
   if (v1.size() != v2.size()) return false;
   int size = v1.size()-1;

   for (int i=0; i<size; i++)
      if ((getStartTagNumber(v1.elementAt(i).toString())) !=
          (getEndTagNumber(v2.elementAt(size-i).toString())))
         return false;

   return true;
}


/**
 */
private boolean inVec(Object o, Vector v) {
   Enumeration enum = v.elements();
   while (enum.hasMoreElements())
      if (o.equals(enum.nextElement()))
         return true;
   return false;
}

/**
 */
private boolean endTagsInSeq(Vector v) {
   Enumeration enum = v.elements();
   while (enum.hasMoreElements())
      if (getEndTagNumber(enum.nextElement().toString())!=-1)
         return true;
   return false;
}


/**
 * true : "   ","",...
 * false: " foo ","a",...
 */
private boolean substringEmpty(String sub) {
   if (sub.length()==0) return true;
   int pos=0;
   StringBuffer sb = new StringBuffer(sub);
   while ((pos=sub.indexOf(" ")) != -1) {
      sb.deleteCharAt(pos);
      sub = sb.toString();
   }

   return sub.equals("");
}


/**
 * Get the Tag-Number in the array startTags
 * If it cannot be found: return -1
 */
private int getStartTagNumber(String tag) {
   for (int i=0; i<startTags.length; i++)
      if (tag.equals(startTags[i]))
         return i;
   return -1;
}


/**
 * Get the Tag-Number in the array endTags
 * If it cannot be found: return -1
 */
private int getEndTagNumber(String tag) {
   for (int i=0; i<endTags.length; i++)
      if (tag.equals(endTags[i]))
         return i;
   return -1;
}

}//class
