package icfp2001;

import java.util.*;

class PLShortcut implements Runnable {

private Thread           thread;
private String s = null;
private boolean ende = false;

private String[] startTags = {"<B>","<I>","<EM>","<S>","<TT>","<U>"};
private String[] endTags =   {"</B>","</I>","</EM>","</S>","</TT>","</U>"};


/**
 * Starts the Thread.
 */
public void startMe(String s) {
   this.s = s;

   thread = new Thread( this );
   thread.start();
}


/**
 * Returns the String.
 */
public String getString() {
   return s;
}

/**
 * Checks the Thread: running?
 */
public boolean isAlive() {
   if ( thread != null )
      return thread.isAlive();
   return false;
}


/**
 */
public void breakIt() {
   this.ende=true;
}


/**
 * Starts the Thread.
 */
public void run() {
   int pos=0;
   String tag = null;
   Vector[] sequence = new Vector[4];
   Vector[] spaces   = new Vector[4];
   int[] seqPos = new int[4];
   int seqNr=0;
   for (int i=0; i<4; i++) {
      sequence[i]=new Vector();
      spaces[i]=new Vector();
   }

   while (((pos=s.indexOf("<", pos)) != -1) && (!ende)) {
      //search first tag from position pos
      tag = s.substring(s.indexOf("<", pos),
                        s.indexOf(">", pos)+1);
      seqPos[seqNr]=pos;
      sequence[seqNr].addElement(tag);
      pos+=tag.length();
      //add all starting tags till there is text or a closing tag
      while (((s.indexOf("<", pos))!=-1) &&
             (substringEmpty(tag=s.substring(pos,s.indexOf("<", pos))))) {
         spaces[seqNr].addElement(s.substring(pos,s.indexOf("<", pos)));
         pos=s.indexOf("<", pos);
         //search next tag from position pos
         tag = s.substring(s.indexOf("<", pos),
                           s.indexOf(">", pos)+1);
         pos+=tag.length();
         sequence[seqNr].addElement(tag);
      }

      seqNr++;
      switch (seqNr) {
         case 1: if ((sequence[0].size()==1) ||
                     (endTagsInSeq(sequence[0]))) {
                    pos = getNextPos(pos, sequence[0]);
                    seqNr=0;
                    sequence[0].removeAllElements();
                    spaces[0].removeAllElements();
                 }
                 break;
         case 2: if (!selfdestruct(sequence[0],
                                   sequence[1])) {
                    pos = getNextPos(pos, sequence[0]);
                    seqNr=0;
                    sequence[0].removeAllElements();
                    sequence[1].removeAllElements();
                    spaces[0].removeAllElements();
                    spaces[1].removeAllElements();
                 }
                 break;
         case 3: if (!sameSeq(sequence[0],
                              sequence[2])) {
                    pos = getNextPos(pos, sequence[0]);
                    seqNr=0;
                    sequence[0].removeAllElements();
                    sequence[1].removeAllElements();
                    sequence[2].removeAllElements();
                    spaces[0].removeAllElements();
                    spaces[1].removeAllElements();
                    spaces[2].removeAllElements();
                 }
                 break;
         case 4: if (selfdestruct(sequence[2],
                                   sequence[3])) {
                    StringBuffer sb = new StringBuffer(s);
                    for (int i=0; i<sequence[3].size(); i++)
                       sb.delete(seqPos[3],
                                 seqPos[3]+sequence[3].elementAt(i).toString().length());
                    if (!spaces[3].isEmpty())
                       for (int i=0; i<spaces[3].size(); i++)
                          sb.delete(seqPos[3],
                                    seqPos[3]+spaces[3].elementAt(i).toString().length());
                    for (int i=0; i<sequence[3].size(); i++)
                       sb.insert(seqPos[3],
                                 sequence[1].elementAt(sequence[1].size()-1-i).toString());
                    if (!spaces[3].isEmpty())
                       for (int i=0; i<spaces[3].size(); i++)
                             sb.insert(seqPos[3],
                                       spaces[3].elementAt(i).toString());
                    for (int i=0; i<sequence[2].size(); i++)
                       sb.delete(seqPos[2],
                                 seqPos[2]+sequence[2].elementAt(i).toString().length());
                    if (!spaces[2].isEmpty())
                       for (int i=0; i<spaces[2].size(); i++)
                          sb.delete(seqPos[2],
                                    seqPos[2]+spaces[2].elementAt(i).toString().length());
                    if (!spaces[2].isEmpty())
                       for (int i=0; i<spaces[2].size(); i++)
                             sb.insert(seqPos[2],
                                       spaces[2].elementAt(i).toString());
                    sb.insert(seqPos[2],"</PL>");
                    for (int i=0; i<sequence[1].size(); i++)
                       sb.delete(seqPos[1],
                                 seqPos[1]+sequence[1].elementAt(i).toString().length());
                    if (!spaces[1].isEmpty())
                       for (int i=0; i<spaces[1].size(); i++)
                          sb.delete(seqPos[1],
                                    seqPos[1]+spaces[1].elementAt(i).toString().length());
                    sb.insert(seqPos[1],"<PL>");
                    if (!spaces[1].isEmpty())
                       for (int i=0; i<spaces[1].size(); i++)
                             sb.insert(seqPos[1],
                                       spaces[1].elementAt(i).toString());
                    s=sb.toString();
                    pos=seqPos[0];
                 }
                 else pos = getNextPos(pos, sequence[0]);
                 seqNr=0;
                 sequence[0].removeAllElements();
                 sequence[1].removeAllElements();
                 sequence[2].removeAllElements();
                 sequence[3].removeAllElements();
                 spaces[0].removeAllElements();
                 spaces[1].removeAllElements();
                 spaces[2].removeAllElements();
                 spaces[3].removeAllElements();
                 break;
      }
   }

}


/**
 */
private int getNextPos(int pos, Vector v) {
   Enumeration enum = v.elements();
   String tag       = null;
   int tagNumber    = 0;
   int tempPos      = pos;
   while (enum.hasMoreElements())
   {
      tag = enum.nextElement().toString();
      if ((tagNumber = getStartTagNumber(tag)) != -1)
        if (tempPos < s.indexOf(endTags[tagNumber], pos))
           tempPos=s.indexOf(endTags[tagNumber], pos);
   }
   return tempPos;
}


/**
 * the same closing tags in v2 as opening in v1 ????
 */
private boolean selfdestruct(Vector v1, Vector v2) {
   if (v1.size() != v2.size()) return false;
   int size = v1.size()-1;

   for (int i=0; i<size; i++)
      if ((getStartTagNumber(v1.elementAt(i).toString())) !=
          (getEndTagNumber(v2.elementAt(size-i).toString())))
         return false;

   return true;
}


/**
 * the same tags
 */
private boolean sameSeq(Vector v1, Vector v2) {
   if (v1.size() != v2.size()) return false;
   int size = v1.size()-1;

   for (int i=0; i<size; i++)
      if (!inVec(v1.elementAt(i),v2))
         return false;

   return true;
}


/**
 */
private boolean inVec(Object o, Vector v) {
   Enumeration enum = v.elements();
   while (enum.hasMoreElements())
      if (o.equals(enum.nextElement()))
         return true;
   return false;
}

/**
 */
private boolean endTagsInSeq(Vector v) {
   Enumeration enum = v.elements();
   while (enum.hasMoreElements())
      if (getEndTagNumber(enum.nextElement().toString())!=-1)
         return true;
   return false;
}


/**
 * true : "   ","",...
 * false: " foo ","a",...
 */
private boolean substringEmpty(String sub) {
   if (sub.length()==0) return true;
   int pos=0;
   StringBuffer sb = new StringBuffer(sub);
   while ((pos=sub.indexOf(" ")) != -1) {
      sb.deleteCharAt(pos);
      sub = sb.toString();
   }

   return sub.equals("");
}


/**
 * Get the Tag-Number in the array startTags
 * If it cannot be found: return -1
 */
private int getStartTagNumber(String tag) {
   for (int i=0; i<startTags.length; i++)
      if (tag.equals(startTags[i]))
         return i;
   return -1;
}


/**
 * Get the Tag-Number in the array endTags
 * If it cannot be found: return -1
 */
private int getEndTagNumber(String tag) {
   for (int i=0; i<endTags.length; i++)
      if (tag.equals(endTags[i]))
         return i;
   return -1;
}

}//class
