package icfp2001;

import java.util.*;

class WhitespaceSimplification implements Runnable {

private Thread           thread;
private String s = null;
private boolean ende = false;

private String[] startTags = {"<B>","<I>","<TT>","<S>","<U>", "<0>","<1>",
                              "<2>","<3>","<4>", "<5>","<6>", "<7>","<8>",
                              "<9>","<r>","<g>", "<b>","<c>", "<m>","<y>",
                              "<k>","<w>"};
private String[] endTags =   {"</B>","</I>","</TT>","</S>","</U>", "</0>",
                              "</1>","</2>","</3>", "</4>","</5>", "</6>",
                              "</7>","</8>","</9>", "</r>","</g>", "</b>",
                              "</c>","</m>","</y>", "</k>","</w>"};




/**
 * Starts the Thread.
 */
public void startMe(String s) {
   this.s = s;

   thread = new Thread( this );
   thread.start();
}


/**
 * Returns the String.
 */
public String getString() {
   return s;
}

/**
 * Checks the Thread: running?
 */
public boolean isAlive() {
   if ( thread != null )
      return thread.isAlive();
   return false;
}


/**
 */
public void breakIt() {
   this.ende=true;
}

/**
 * Starts the Thread.
 */
public void run() {
   int pos=0;
   String tag = null;
   //Variables for Sequences
   Vector[] sequence = new Vector[3];
   Vector[] spaces   = new Vector[3];
   Vector helpSeq = new Vector();
   int[]    seqPos = new int[3];
   int      seqNr=0;
   for (int i=0; i<3; i++) {
      sequence[i]=new Vector();
      spaces[i]=new Vector();
   }

   while (((pos=s.indexOf("<", pos)) != -1) && (!ende)) {
      //search first tag from position pos
      tag = s.substring(s.indexOf("<", pos),
                        s.indexOf(">", pos)+1);
      seqPos[seqNr]=pos;
      sequence[seqNr].addElement(tag);
      pos+=tag.length();
      //add all starting tags till there is text or a closing tag
      while (((s.indexOf("<", pos))!=-1) &&
             (substringEmpty(tag=s.substring(pos,s.indexOf("<", pos))))) {
         spaces[seqNr].addElement(s.substring(pos,s.indexOf("<", pos)));
         pos=s.indexOf("<", pos);
         //search next tag from position pos
         tag = s.substring(s.indexOf("<", pos),
                           s.indexOf(">", pos)+1);
         pos+=tag.length();
         sequence[seqNr].addElement(tag);
      }

      seqNr++;
      switch (seqNr) {
         case 1: if (endTagsInSeq(sequence[0])) {
                    seqNr=0;
                    sequence[0].removeAllElements();
                    spaces[0].removeAllElements();
                 }
                 break;
         case 2: helpSeq = getHelpSeq((Vector)sequence[0].clone(),
                                      (Vector)sequence[1].clone());
                 if (helpSeq == null) break;
                 if (!helpSeq.isEmpty())
                    if (helpSeq.elementAt(0).toString().equals("fail")) {
                       seqNr=0;
                       sequence[0].removeAllElements();
                       sequence[1].removeAllElements();
                       spaces[0].removeAllElements();
                       spaces[1].removeAllElements();
                       helpSeq.removeAllElements();
                    }
                 break;
         case 3: if (selfdestruct((Vector)helpSeq.clone(),
                                  (Vector)sequence[0].clone(),
                                  (Vector)sequence[2].clone())) {
                    StringBuffer sb = new StringBuffer(s);
                    for (int i=0; i<sequence[1].size(); i++)
                       sb.delete(seqPos[1],
                                 seqPos[1]+sequence[1].elementAt(i).toString().length());
                    if (!spaces[1].isEmpty())
                       for (int i=0; i<spaces[1].size(); i++)
                          sb.delete(seqPos[1],
                                    seqPos[1]+spaces[1].elementAt(i).toString().length());
                    if (helpSeq!=null)
                       for (int i=0; i<helpSeq.size(); i++)
                          sb.insert(seqPos[1],
                                    helpSeq.elementAt(i).toString());
                    if (!spaces[1].isEmpty())
                       for (int i=0; i<spaces[1].size(); i++)
                             sb.insert(seqPos[1],
                                       spaces[1].elementAt(i).toString());
                    for (int i=0; i<sequence[0].size(); i++)
                       sb.delete(seqPos[0],
                                 seqPos[0]+sequence[0].elementAt(i).toString().length());
                    if (!spaces[0].isEmpty())
                       for (int i=0; i<spaces[0].size(); i++)
                          sb.delete(seqPos[0],
                                    seqPos[0]+spaces[0].elementAt(i).toString().length());
                    if (!spaces[0].isEmpty())
                       for (int i=0; i<spaces[0].size(); i++)
                             sb.insert(seqPos[0],
                                       spaces[0].elementAt(i).toString());
                    if (helpSeq!=null)
                       for (int i=helpSeq.size()-1; i>=0; i--)
                          sb.insert(seqPos[0],
                                    startTags[getEndTagNumber(helpSeq.elementAt(i).toString())]);
                    for (int i=0; i<sequence[2].size(); i++)
                       sb.insert(seqPos[0],
                                 startTags[getEndTagNumber(sequence[2].elementAt(i).toString())]);
                    s=sb.toString();
                 }
                 pos=seqPos[1];
                 seqNr=0;
                 sequence[0].removeAllElements();
                 sequence[1].removeAllElements();
                 sequence[2].removeAllElements();
                 spaces[0].removeAllElements();
                 spaces[1].removeAllElements();
                 spaces[2].removeAllElements();
                 if (helpSeq != null)
                    helpSeq.removeAllElements();
                 break;
      }
   }

}


/**
 * i.e.: v1 = ["<B>","<I>","<r>"]
 *       v2 = ["</r>","</I>","<B>","<r>","<I>"]
 *       helpSeq = ["<B>"]
 */
private Vector getHelpSeq(Vector v1, Vector v2) {
   Vector helpSeq = new Vector();
   int act = 0,
       size = v1.size();
   boolean ok    = true,
           dummy = false;

   try {
      for (int i=0; i<size; i++)
         if (v2.removeElement(v1.elementAt(act)))
            if (v2.removeElement(endTags[getStartTagNumber(v1.elementAt(act).toString())]))
               dummy = v1.removeElement(v1.elementAt(act));
            else {
               helpSeq.addElement("fail");
               return helpSeq;
            }
         else act++;

      if (v1==null && v2==null)
         return null;
      else if (!selfdestruct(v1,v2)) {
         helpSeq.addElement("fail");
         return helpSeq;
      }
   }
   catch (ArrayIndexOutOfBoundsException e) {
      helpSeq.addElement("fail");
      return helpSeq;
   }

   return (Vector)v2.clone();
}

/**
 * the same closing tags in v2 as opening in v1 ????
 */
private boolean selfdestruct(Vector help, Vector v1, Vector v2) {
   for (int i=0; i<help.size(); i++)
      v2.addElement(help.elementAt(i));
   if (v1.size() != v2.size()) return false;

   boolean dummy = false;
   int size=v1.size();
   for (int i=0; i<size; i++)
      if (v2.removeElement(endTags[getStartTagNumber(v1.elementAt(0).toString())]))
         dummy = v1.removeElement(v1.elementAt(0));
      else
         return false;

   if (v1.isEmpty() && v2.isEmpty())
      return true;
   else
      return false;
}


/**
 * the same closing tags in (v2+help) as opening in v1 ????
 */
private boolean selfdestruct(Vector v1, Vector v2) {
   if (v1.size() != v2.size()) return false;
   int size = v1.size()-1;

   for (int i=0; i<size; i++)
      if ((getStartTagNumber(v1.elementAt(i).toString())) !=
          (getEndTagNumber(v2.elementAt(size-i).toString())))
         return false;

   return true;
}


/**
 */
private boolean endTagsInSeq(Vector v) {
   Enumeration enum = v.elements();
   while (enum.hasMoreElements())
      if (getEndTagNumber(enum.nextElement().toString())!=-1)
         return true;
   return false;
}


/**
 * true : "   ","",...
 * false: " foo ","a",...
 */
private boolean substringEmpty(String sub) {
   if (sub.length()==0) return true;
   int pos=0;
   StringBuffer sb = new StringBuffer(sub);
   while ((pos=sub.indexOf(" ")) != -1) {
      sb.deleteCharAt(pos);
      sub = sb.toString();
   }

   return sub.equals("");
}


/**
 * Get the Tag-Number in the array startTags
 * If it cannot be found: return -1
 */
private int getStartTagNumber(String tag) {
   for (int i=0; i<startTags.length; i++)
      if (tag.equals(startTags[i]))
         return i;
   return -1;
}


/**
 * Get the Tag-Number in the array endTags
 * If it cannot be found: return -1
 */
private int getEndTagNumber(String tag) {
   for (int i=0; i<endTags.length; i++)
      if (tag.equals(endTags[i]))
         return i;
   return -1;
}

}//class
